// BEGIN LICENSE BLOCK
// Version: CMPL 1.1
//
// The contents of this file are subject to the Cisco-style Mozilla Public
// License Version 1.1 (the "License"); you may not use this file except
// in compliance with the License.  You may obtain a copy of the License
// at www.eclipse-clp.org/license.
// 
// Software distributed under the License is distributed on an "AS IS"
// basis, WITHOUT WARRANTY OF ANY KIND, either express or implied.  See
// the License for the specific language governing rights and limitations
// under the License. 
// 
// The Original Code is  CPViz Constraint Visualization System
// The Initial Developer of the Original Code is  Helmut Simonis
// Portions created by the Initial Developer are
// Copyright (C) 2009-2010 Helmut Simonis
// 
// Contributor(s): 	Helmut Simonis, 4C, Univerity College Cork, Cork
//			
// 
// END LICENSE BLOCK
// ----------------------------------------------------------------------
package ie.ucc.cccc.viz;

import java.util.*;

/**
 * Data structure to hold information for an argument tuple. Access of 
 * tuple fields is through string lookup values. We currently assume that 
 * tuple fields are DVar of Integer
 * @author hsimonis
 *
 */
public class Tuple {
	private Map<String,FullDomain> map = new HashMap<String,FullDomain>();
	
	/**
	 * add an entry to a tuple, used by the parser, not by the user code
	 * @param key String
	 * @param value a FullDomain domain
	 */
	public void add(String key,FullDomain value){
		map.put(key,value);
	}
	
	/**
	 * get the domain associated to the tuple field with name key
	 * @param key string
	 * @return corresponding field value stored in tuple
	 */
	public FullDomain getField(String key){
		return map.get(key);
	}
}
